// Phenakistoscope disc creator

// by Yoruk for Instructables

// send commments or questions to Yoruk16_72 AT yahoo DOT fr


// final disc (high quality) : add  "-q0 -w1000 -h1000  +a " to the command line

      

// 16 12 15 : code initial    
// 20 12 15 : lecture frames extraites d'un GIF
        
        
#version 3.7;


//commande extraction ffmpeg : ffmpeg -i ..\runner.gif  -ignore_loop true ..\out%02d.png           

//l'AA est ncessaire sinon images moches      
      

#declare Nbframes = 12;  //number of frames




//drawing parameters                                                          
#declare RayonEncoches = 0.7;                   
#declare LargeurEncoches = 0.04;   
#declare Epaisseur = 0.003; //of the black lines  
#declare TracerBordures = false; //add grey lines to see frames limits. Set it to false for final printing

                 

//frames parameters                    
#declare Activate1 = true;          //activate the level or not
#declare PrefixeImage1 = "Simba1";  // pictures : out01.png,  out02.png...
#declare Scale1 =  0.3         ;    //global scale of the object. Adjust if it doesn't fit correctly    
#declare VerticalOffset1 = 0.83;    //distance between the center of the disc and the picture
#declare AngularOffset1 = 0;        //rotate around the disc axis for a few degrees? Use it to center the picture                      
#declare Ratio1 = 187/141;  
#declare Mirror1 = true;    
                    
                    
#declare Activate2 = true;   
#declare PrefixeImage2 = "Simba2";   
#declare Scale2 =     0.27  ;
#declare VerticalOffset2 = 0.55   ;
#declare AngularOffset2 = 0;     
#declare Ratio2 = 107/87; 
#declare Mirror2 = true;     
              
              
#declare Activate3 = false;   
#declare PrefixeImage3 = "";   
#declare Scale3 =     0.25  ;
#declare VerticalOffset3 = 0.3   ;   
#declare AngularOffset3 = 2;    
#declare Ratio3 = 3;  
#declare Mirror3 = true;  




background {color rgb 1}


global_settings {assumed_gamma 1.0}         


difference {      //cercle ext 

    torus { 1,Epaisseur rotate x*90} 

    union {  

        #local Nr = 0;     
        #while (Nr< 360) 

                cylinder {  <- LargeurEncoches/2,1,0> , <LargeurEncoches/2 ,1,0>, 0.05  rotate z* Nr   }

        #local Nr = Nr + (360/Nbframes);  
        #end 
        
    }

    pigment { color rgb 0 }

}                


#if (TracerBordures)   
        #local Nr = 0;     
        #while (Nr< 360)                        
        cylinder {   <0,0.02,0> , <0,RayonEncoches,0>, Epaisseur 
                rotate z* Nr  pigment { color rgb 0.2 } 
        }                              
        #local Nr = Nr + (360/Nbframes);  
        #end
#end      
     

union {  
    torus { 0.02,Epaisseur rotate x*90 }   //trou central 


#local Nr = 0;     // construction encoche  
#while (Nr< 360) 

    //   |_|

    cylinder { <- LargeurEncoches/2,RayonEncoches,0> , <LargeurEncoches/2 ,RayonEncoches,0>, Epaisseur rotate z* Nr }
    cylinder { <- LargeurEncoches/2,RayonEncoches,0> , <-LargeurEncoches/2 ,1,0>, Epaisseur rotate z* Nr }
    cylinder { < LargeurEncoches/2,RayonEncoches,0> , <LargeurEncoches/2 ,1,0>, Epaisseur rotate z* Nr }
    sphere { <- LargeurEncoches/2,RayonEncoches,0> , Epaisseur rotate z* Nr }
    sphere { < LargeurEncoches/2,RayonEncoches,0> , Epaisseur rotate z* Nr }      

#local Nr = Nr +  (360/Nbframes);  ;  
#end 

    pigment { color rgb 0 }  

}
   

camera {
    //orthographic
    location <0,0,2.1>
    look_at <0,0,0> 
    right -x*image_width/image_height   
}              

     
light_source {<0,0,2.1> color rgb 1}    
     

// les images
  
#local Nr = 1;     
#while (Nr< Nbframes+1) 

#declare NomFrameRang1 = concat(PrefixeImage1 ,str(Nr,-2,0) , ".png")
#debug "\n"
#debug NomFrameRang1 
  
#declare NomFrameRang2 = concat(PrefixeImage2 ,str(Nr,-2,0) , ".png")
#debug "\n"
#debug NomFrameRang2   

#declare NomFrameRang3 = concat(PrefixeImage3 ,str(Nr,-2,0) , ".png")
#debug "\n"
#debug NomFrameRang3                         

#if (Activate1)        
box { 
        <0,0,0>,<1,1,0.01>                      

        pigment {  image_map {  png NomFrameRang1 } } 
        translate <-0.5,-0.5,-0.1>   //un peu en Z pour tre sous les traits de decoupe
                              
        #if(Mirror1)   
                rotate y*180 //vertical flip  
        #end                  
                              
        scale Scale1 
        scale <1,1/Ratio1,1>  
        translate y*VerticalOffset1    
        rotate z*((180/Nbframes) + Nr * (360/Nbframes) +AngularOffset1)

} 
#end  

#if (Activate2)  
box { 
        <0,0,0>,<1,1,0.01>     //second rang                  

        pigment { image_map  {  png NomFrameRang2 } }    
        translate <-0.5,-0.5,-0.2>     //un peu en Z pour tre sous les traits de decoupe
               
        #if(Mirror2)   
              rotate y*180 //vertical flip  
        #end   
                
        scale Scale2   
        scale <1,1/Ratio2,1     >
        translate y* VerticalOffset2   
        rotate z*((180/Nbframes) + Nr * (360/Nbframes) +AngularOffset2)  
} 
#end  

#if (Activate3) 
box { 
        <0,0,0>,<1,1,0.01>     //troisieme rang                  

        pigment { image_map  {png NomFrameRang3  } }  
        translate <-0.5,-0.5,-0.2>     //un peu en Z pour tre sous les traits de decoupe
                    
        #if(Mirror3)   
                rotate y*180 //vertical flip  
        #end
     
        scale Scale3   
        scale <1,1/Ratio3,1     >
        translate y* VerticalOffset3  
        rotate z*((180/Nbframes) + Nr * (360/Nbframes) +AngularOffset3)
}    
#end 



#local Nr = Nr +1  ;  
#end    


//fin de fichier                